﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace starField
{
	/// <summary>
	/// Interaktionslogik für MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		static System.Windows.Forms.Timer myTimer = new System.Windows.Forms.Timer();

		int starsCount = 400;

		int[] x;
		int[] y;
		int[] z;

		double[] cos;
		double[] sin;


		int wx = 0;
		int wy = 0;
		int wz = 0;

		Random rnd = new Random();

		public MainWindow()
		{
			InitializeComponent();

			x = new int[starsCount];
			y = new int[starsCount];
			z = new int[starsCount];

			cos = new double[256];
			sin = new double[256];

			for (int i = 0; i < 256; i++)
			{
				sin[i] = Math.Sin(i * (Math.PI / 128));
				cos[i] = Math.Cos(i * (Math.PI / 128));
			}

			for (int i = 0; i < starsCount; i++)
			{
				x[i] = (int)(90 - rnd.Next(180));
				y[i] = (int)(90 - rnd.Next(180));
				z[i] = (int)(90 - rnd.Next(180));
			}

			myTimer.Tick += new EventHandler(TimerEventProcessor);
			myTimer.Interval = 16;
			myTimer.Start();
		}

		private void TimerEventProcessor(object sender, EventArgs e)
		{
			for (int i = 0; i < starsCount; i++)
			{
				x[i]++;

				if (x[i] > 90)
					x[i] = -90;
			}

			drawStarfield();
		}

		private void AddPixel(double x, double y, double z)
		{
			Rectangle rec = new Rectangle();
			Canvas.SetTop(rec, y * 1.5 + 200);
			Canvas.SetLeft(rec, x * 1.5 + 320);
			rec.Width = 2;
			rec.Height = 2;
			rec.Fill = new SolidColorBrush(Color.FromRgb((byte)(z + 128), (byte)(z + 128), (byte)(z + 128)));
			myCanvas.Children.Add(rec);
		}

		private void drawStarfield()
		{
			wx = (int)sliderX.Value;
			wy = (int)sliderY.Value;
			wz = (int)sliderZ.Value;

			myCanvas.Children.Clear();

			for (int i = 0; i < starsCount; i++)
			{

				// Z-Achse
				int x1 = (int)(x[i] * cos[wz] - y[i] * sin[wz]);
				int y1 = (int)(x[i] * sin[wz] + y[i] * cos[wz]);
				int z1 = z[i];

				// X-Achse
				int x2 = x1;
				int y2 = (int)(y1 * cos[wx] - z1 * sin[wx]);
				int z2 = (int)(y1 * sin[wx] + z1 * cos[wx]);

				// Y-Achse
				int x3 = (int)(z2 * sin[wy] + x2 * cos[wy]);
				int y3 = y2;
				int z3 = (int)(z2 * cos[wy] - x2 * sin[wy]);

				// Perspektive
				int d = -127;
				int x4 = d * x3 / ((int)(0 - (90 * 2)) + z3);
				int y4 = d * y3 / ((int)(0 - (90 * 2)) + z3);

				AddPixel(x4, y4, z3);
			}
		}
	}
}
